
CREATE TABLE SRI_USER(
ID bigint NOT NULL  AUTO_INCREMENT ,
USERNAME varchar(255) NOT NULL ,
PASSWORD varchar(255) NULL ,
SALT varchar(250) NULL ,
ALGORITHM varchar(50) NULL ,
DEFAULT_STORE_ID varchar(255) NULL ,
PRIMARY KEY (ID),
CONSTRAINT AK_USER UNIQUE (USERNAME))
;

CREATE TABLE ACCESS_RULE(
RULE_NAME varchar(255) NOT NULL ,
PRIMARY KEY (RULE_NAME))
;

CREATE TABLE ACCESS_RULE_IMPLICIT(
RULE_NAME varchar(255) NOT NULL ,
IMPLIES_RULE_NAME varchar(255) NOT NULL ,
PRIMARY KEY (RULE_NAME,IMPLIES_RULE_NAME))
;

CREATE TABLE USER_PERMISSION(
ID bigint NOT NULL ,
RULE_NAME varchar(255) NOT NULL ,
PRIMARY KEY (ID,RULE_NAME))
;

CREATE TABLE MS_STORE(
STORE_ID varchar(255) NOT NULL ,
PRIMARY KEY (STORE_ID))
;

CREATE TABLE MS_STORE_USER(
STORE_ID varchar(255) NOT NULL ,
ID bigint NOT NULL ,
PRIMARY KEY (STORE_ID,ID))
;

CREATE TABLE AUTH_DB_VERSION(
MAJOR bigint NOT NULL ,
MINOR bigint NOT NULL ,
UPGRADE_STAMP datetime NOT NULL  DEFAULT CURRENT_TIMESTAMP ,
PRIMARY KEY (MAJOR,MINOR))
;

ALTER TABLE SRI_USER ADD CONSTRAINT FK_USER_DEFAULT_STORE FOREIGN KEY (DEFAULT_STORE_ID) REFERENCES MS_STORE (STORE_ID)
;

ALTER TABLE USER_PERMISSION ADD CONSTRAINT FK_USER_PERMISSION_USER FOREIGN KEY (ID) REFERENCES SRI_USER (ID)
ON DELETE CASCADE
;

ALTER TABLE USER_PERMISSION ADD CONSTRAINT FK_USER_PERMISSION_RULE FOREIGN KEY (RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
ON DELETE CASCADE
;

ALTER TABLE ACCESS_RULE_IMPLICIT ADD CONSTRAINT FK_PARENT_RULE FOREIGN KEY (RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
ON DELETE CASCADE
;

ALTER TABLE ACCESS_RULE_IMPLICIT ADD CONSTRAINT FK_IMPLICIT_RULE FOREIGN KEY (IMPLIES_RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
;

ALTER TABLE MS_STORE_USER ADD CONSTRAINT FK_USER_MS_STORE FOREIGN KEY (ID) REFERENCES SRI_USER (ID)
ON DELETE CASCADE
;

ALTER TABLE MS_STORE_USER ADD CONSTRAINT FK_MS_STORE_USER FOREIGN KEY (STORE_ID) REFERENCES MS_STORE (STORE_ID)
ON DELETE CASCADE
;
DROP PROCEDURE IF EXISTS INSERT_SRI_USER
;

CREATE PROCEDURE INSERT_SRI_USER(
IN p_username varchar(255),
IN p_password varchar(255),
IN p_salt varchar(250),
IN p_algorithm varchar(50),
IN p_default_store_id varchar(255),
OUT p_pk bigint)
BEGIN
		INSERT INTO SRI_USER (USERNAME,PASSWORD,SALT,ALGORITHM,DEFAULT_STORE_ID) VALUES (p_username, p_password, p_salt, p_algorithm, p_default_store_id);
		set p_pk = LAST_INSERT_ID();
END;
;

